import { FieldDefinition, FieldSchema, FieldType, MapOf, TableSchema } from "../types";
export default class FieldSchemaModel implements FieldSchema {
    readonly table: TableSchema;
    readonly name: string;
    readonly propName: string;
    readonly type: FieldType;
    readonly references?: string;
    readonly relationName?: string;
    readonly cascade: boolean;
    readonly unique: boolean;
    readonly notNull: boolean;
    readonly isPrimaryKey: boolean;
    readonly isForeignKey: boolean;
    readonly isStamp: boolean;
    private _refTable?;
    private _valueFactory?;
    constructor(table: TableSchema, name: string, schema: FieldDefinition, cascadeAsDefault?: boolean);
    readonly refTable: TableSchema | undefined;
    connect(schemas: MapOf<TableSchema>): void;
    getValue(data: any, record?: any): any;
    getRecordValue(record: {
        value: any;
    }): any;
}
