import { ForeignKey, MapOf, TableIndex, TableState } from "./types";
export declare const merge: (original: TableState<any>, modified: Partial<TableState<any>>) => {
    byId: MapOf<any>;
    ids: string[];
    name?: string | undefined;
    indexes: MapOf<TableIndex>;
};
export declare const splice: (original: TableState<any>, idsToDelete: string[]) => {
    deleted: {
        id: string;
        record: any;
    }[];
    state: {
        byId: {
            [x: string]: any;
        };
        ids: string[];
        indexes: {
            [x: string]: TableIndex;
        };
        name?: string | undefined;
    };
};
export declare const updateIndexes: (name: string, original: TableState<any>, modified: TableState<any>) => void;
export declare const cleanIndexes: (keys: ForeignKey[], id: string, indexes: MapOf<TableIndex>) => void;
declare const _default: {
    cleanIndexes: (keys: ForeignKey[], id: string, indexes: MapOf<TableIndex>) => void;
    merge: (original: TableState<any>, modified: Partial<TableState<any>>) => {
        byId: MapOf<any>;
        ids: string[];
        name?: string | undefined;
        indexes: MapOf<TableIndex>;
    };
    splice: (original: TableState<any>, idsToDelete: string[]) => {
        deleted: {
            id: string;
            record: any;
        }[];
        state: {
            byId: {
                [x: string]: any;
            };
            ids: string[];
            indexes: {
                [x: string]: TableIndex;
            };
            name?: string | undefined;
        };
    };
    updateIndexes: (name: string, original: TableState<any>, modified: TableState<any>) => void;
};
export default _default;
