// tslint:disable:max-line-length
export default {
    argument: function (name, type) { return "Missing a valid " + type + " for the argument \"" + name + "\""; },
    argumentShape: function (name, props) { return "Argument \"" + name + "\" has an invalid shape. Missing required props: \"" + props.join(", ") + "\""; },
    fkInvalid: function (table, key) { return "The foreign key " + table + "." + key + " is invalid"; },
    fkInvalidReference: function (table, key, reference) { return "The field schema \"" + table + "." + key + "\" has an invalid reference to unknown table \"" + reference + "\"."; },
    fkReferenceNotInSession: function (key, references) { return "The foreign key: \"" + key + "\" references an unregistered table: \"" + references + "\" in the current session."; },
    fkUndefined: function (table, key) { return "No foreign key named: " + key + " in the schema: \"" + table + "\"."; },
    fkViolation: function (table, key) { return "The insert/update operation violates the unique foreign key \"" + table + "." + key + "\"."; },
    invalidId: function () { return 'The given value is not a valid "id". An "id" must be a non-empty string or a number.'; },
    normalizeInvalidData: function () { return "Failed to normalize data. Given argument is not a plain object nor an array."; },
    normalizeInvalidFk: function (table, key, refTable) { return "Invalid schema definition. The field \"" + table + "." + key + "\" is referencing table \"" + refTable + "\", but the given data is an array."; },
    normalizePk: function (name) { return "Failed to normalize primary key for record of type \"" + name + "\". Make sure record(s) have a primary key value before trying to insert or update a table."; },
    normalizeFkViolation: function (table, key) { return "The insert/update operation violates the unique foreign key \"" + table + "." + key + "\"."; },
    pkNotFound: function (table) { return "Failed to get primary key for record of type \"" + table + "\"."; },
    recordNotFound: function (table, id) { return "No \"" + table + "\" record with id: " + id + " exists."; },
    recordUpdateViolation: function (table, id) { return "Failed to apply update. No \"" + table + "\" record with id: " + id + " exists."; },
    reservedProperty: function (name, prop) { return "The property \"" + name + "." + prop + "\" is a reserved name. Please specify another name using the \"propName\" definition."; },
    sessionReadonly: function () { return "Invalid attempt to alter a readonly session."; },
    stateTableUndefined: function () { return "Failed to select table. Could not identify table schema."; },
    tableInvalidState: function (table) { return "The table \"" + table + "\" has an invalid state."; },
    tableNotInSession: function (table) { return "The table: \"" + table + "\" does not exist in the current session."; },
    uniqueConstraintViolation: function (id) { return "Operation violates unique constraint for id: \"" + id + "\""; },
    unknownTableState: function () { return "Failed to identifiy table state."; }
};
