import { ensureParamObject } from "../utils";
var DbNormalizeContext = /** @class */ (function () {
    function DbNormalizeContext(schema, options) {
        this.output = {};
        this.emits = {};
        this.schema = ensureParamObject("schema", schema, "db");
        this.db = ensureParamObject("schema.db", this.schema.db);
        this.table = options.table;
        this.normalizePKs = options.normalizePKs === true;
        this.argument = options.argument;
    }
    DbNormalizeContext.prototype.emit = function (tableName, record) {
        this.emits[tableName] = this.emits[tableName] || [];
        this.emits[tableName].push(record);
    };
    return DbNormalizeContext;
}());
export default DbNormalizeContext;
