import { DatabaseSchema, FieldSchema, MapOf, NormalizeContext, TableDefinition, TableRecord, TableSchema } from "../types";
export default class TableSchemaModel implements TableSchema {
    readonly db: DatabaseSchema;
    readonly name: string;
    readonly fields: FieldSchema[];
    private _normalizer;
    private _relations;
    private _primaryKeyFields;
    private _foreignKeyFields;
    private _stampFields;
    constructor(db: DatabaseSchema, name: string, definition: TableDefinition);
    readonly relations: FieldSchema[];
    readonly primaryKeys: FieldSchema[];
    connect(tableMap: MapOf<TableSchema>): void;
    inferRelations(data: any, rel: FieldSchema, ownerId: string): any[];
    normalize(data: any, context: NormalizeContext): string[];
    injectKeys(data: any, record: TableRecord): any;
    ensurePrimaryKey(record: any): string;
    getPrimaryKey(record: any): string | undefined;
    getForeignKeys(record: any): {
        name: string;
        notNull: boolean;
        references: string;
        refTable: TableSchema;
        unique: boolean;
        value: any;
    }[];
    isModified(x: any, y: any): boolean;
    mergeRecord(oldRecord: any, newRecord: any): any;
}
