define("types",["require","exports"],function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define("constants",["require","exports"],function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TYPE_PK="PK",t.TYPE_ATTR="ATTR",t.TYPE_MODIFIED="MODIFIED",t.ALL="*",t.RESERVED_PROPERTIES=["id","table","value","_fields","delete","update"],t.initialState=function(e){return{ids:[],byId:{},indexes:{},name:e}}}),define("errors",["require","exports"],function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default={argument:function(e,t){return"Missing a valid "+t+' for the argument "'+e+'"'},argumentShape:function(e,t){return'Argument "'+e+'" has an invalid shape. Missing required props: "'+t.join(", ")+'"'},fkInvalid:function(e,t){return"The foreign key "+e+"."+t+" is invalid"},fkInvalidReference:function(e,t,r){return'The field schema "'+e+"."+t+'" has an invalid reference to unknown table "'+r+'".'},fkReferenceNotInSession:function(e,t){return'The foreign key: "'+e+'" references an unregistered table: "'+t+'" in the current session.'},fkUndefined:function(e,t){return"No foreign key named: "+t+' in the schema: "'+e+'".'},fkViolation:function(e,t){return'The insert/update operation violates the unique foreign key "'+e+"."+t+'".'},invalidId:function(){return'The given value is not a valid "id". An "id" must be a non-empty string or a number.'},normalizeInvalidData:function(){return"Failed to normalize data. Given argument is not a plain object nor an array."},normalizeInvalidFk:function(e,t,r){return'Invalid schema definition. The field "'+e+"."+t+'" is referencing table "'+r+'", but the given data is an array.'},normalizePk:function(e){return'Failed to normalize primary key for record of type "'+e+'". Make sure record(s) have a primary key value before trying to insert or update a table.'},normalizeFkViolation:function(e,t){return'The insert/update operation violates the unique foreign key "'+e+"."+t+'".'},pkNotFound:function(e){return'Failed to get primary key for record of type "'+e+'".'},recordNotFound:function(e,t){return'No "'+e+'" record with id: '+t+" exists."},recordUpdateViolation:function(e,t){return'Failed to apply update. No "'+e+'" record with id: '+t+" exists."},reservedProperty:function(e,t){return'The property "'+e+"."+t+'" is a reserved name. Please specify another name using the "propName" definition.'},sessionReadonly:function(){return"Invalid attempt to alter a readonly session."},stateTableUndefined:function(){return"Failed to select table. Could not identify table schema."},tableInvalidState:function(e){return'The table "'+e+'" has an invalid state.'},tableNotInSession:function(e){return'The table: "'+e+'" does not exist in the current session.'},uniqueConstraintViolation:function(e){return'Operation violates unique constraint for id: "'+e+'"'},unknownTableState:function(){return"Failed to identifiy table state."}}}),define("utils",["require","exports","tslib","errors"],function(e,a,t,o){"use strict";Object.defineProperty(a,"__esModule",{value:!0}),o=t.__importDefault(o),a.toArray=function(t){return t?Array.isArray(t)?t:"object"==typeof t?Object.keys(t).map(function(e){return t[e]}):[]:[]},a.ensureArray=function(e){return void 0===e||null==e?[]:Array.isArray(e)?e:[e]},a.isObject=function(e){return null!==e&&!Array.isArray(e)&&"object"==typeof e},a.isPlainObject=function(e){if(a.isObject(e)){if("function"!=typeof Object.getPrototypeOf)return"[object Object]"===Object.prototype.toString.call(e);var t=Object.getPrototypeOf(e);return t===Object.prototype||null===t}return!1},a.ensureParam=function(e,t){if(void 0===t)throw new Error(o.default.argument(e,"value"));return t},a.ensureParamString=function(e,t){if(null==t||"string"!=typeof t||0===t.length)throw new Error(o.default.argument(e,"string"));return t},a.ensureParamObject=function(e,t){for(var r=[],n=2;n<arguments.length;n++)r[n-2]=arguments[n];if(!t||!a.isObject(t))throw new Error(o.default.argument(e,"object"));if(r){var i=r.filter(function(e){return void 0===t[e]});if(i.length)throw new Error(o.default.argumentShape(e,i))}return t},a.ensureParamFunction=function(e,t){if(!t||"function"!=typeof t)throw new Error(o.default.argument(e,"function"));return t},a.optionalParamString=function(e,t,r){return void 0!==t?a.ensureParamString(e,t):r},a.ensureID=function(e){if(!a.isValidID(e))throw new Error(o.default.invalidId());return a.asID(e)},a.isValidID=function(e){return null!=e&&("string"==typeof e&&0<e.length||"number"==typeof e)},a.asID=function(e){return"string"==typeof e?e:e.toString()},a.toObject=function(e,r){return e.reduce(function(e,t){return e[r(t)]=t,e},{})},a.mergeIds=function(e,t,r){var n,i={};for(n=0;n<e.length;n++)i[e[n]]=!0;for(n=0;n<t.length;n++){if(r&&i[t[n]])throw new Error(o.default.uniqueConstraintViolation(t[n]));i[t[n]]=!0}return Object.keys(i)},a.isEqual=function(e,t){if(e===t)return!0;var r=Object.keys(e),n=Object.keys(t),i=r.length;if(n.length!==i)return!1;for(var a=0;a<i;a++){var o=r[a];if(!(Array.isArray(e[o])&&Array.isArray(t[o])&&s(e[o],t[o]))&&e[o]!==t[o])return!1}return!0};var s=function(e,t){if(e===t)return!0;var r=e.length;if(t.length!==r)return!1;for(var n=0;n<r;n++)if(e[n]!==t[n])return!1;return!0}}),define("ModelFactory",["require","exports","tslib","constants","errors","utils"],function(e,n,i,a,o,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),o=i.__importDefault(o),r=i.__importStar(r),n.createRecordModelClass=function(e){return function(n){function e(e,t){var r=n.call(this,e,t)||this;return r._fields={},r}return i.__extends(e,n),e}(e)};var s=function(){function e(e,t){this._recordClass={},this._defineProperty=function(e,t,r,n,i){if(void 0===i&&(i=!0),0<=a.RESERVED_PROPERTIES.indexOf(t))throw new Error(o.default.reservedProperty(r.table.name,t));Object.defineProperty(e.prototype,t,{get:function(){return i?this._fields[t]||(this._fields[t]=n(r,this)):n(r,this)}})},this._recordBaseType=e,this._factory=t}return e.prototype.newRecordModel=function(e,t){return r.ensureParamString("id",e),r.ensureParamObject("table",t),new(this.createRecordModel(t.schema))(e,t)},e.prototype.createRecordModel=function(e){var t=this;if(this._recordClass[e.name])return this._recordClass[e.name];var r=n.createRecordModelClass(this._recordBaseType);return e.fields.forEach(function(e){return(e.isForeignKey||!e.isPrimaryKey)&&t._defineProperty(r,e.propName,e,t._newRecordField.bind(t),!1)}),e.relations.forEach(function(e){return e.relationName&&t._defineProperty(r,e.relationName,e,e.unique?t._newRecordRelation.bind(t):t._newRecordSet.bind(t),!e.unique)}),this._recordClass[e.name]=r},e.prototype._newRecordField=function(e,t){if(!e.isForeignKey)return this._factory.newRecordFieldModel(e,t);var r=e.references&&t.table.session.tables[e.references];if(!r)throw new Error(o.default.fkReferenceNotInSession(e.name,e.references));var n=e.getRecordValue(t);return void 0===n?null:r.get(n)},e.prototype._newRecordSet=function(e,t){var r=t.table.session.tables[e.table.name];if(!r)throw new Error(o.default.tableNotInSession(e.table.name));return this._factory.newRecordSetModel(r,e,t)},e.prototype._newRecordRelation=function(e,t){var r=t.table.session.tables[e.table.name];if(!r)throw new Error(o.default.tableNotInSession(e.table.name));var n=r.getIndex(e.name,t.id)[0];return void 0===n?null:this.newRecordModel(n,r)},e}();n.RecordModelFactory=s;n.default=function(e,t){var r=new s(t,e);return i.__assign({},e,{newRecordModel:function(e,t){return r.newRecordModel(e,t)}})}}),define("Normalizer",["require","exports","tslib","constants","errors","utils"],function(e,t,u,r,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),l=u.__importDefault(l),c=u.__importStar(c);var n=function(){function e(e){this.schema=e,this.db=e.db}return e.prototype.normalize=function(e,o){var s=this;if(!c.isPlainObject(e)&&!Array.isArray(e))throw new Error(l.default.normalizeInvalidData());return c.ensureParamObject("context",o),c.ensureParamObject("context.output",o.output),o.output[this.schema.name]||(o.output[this.schema.name]=r.initialState(this.schema.name)),c.ensureArray(e).map(function(e){if(!c.isPlainObject(e))throw new Error(l.default.normalizeInvalidData());var t=e,r=s.db.getRecordNormalizer(s.schema.name);r&&(t=r(t,o));var n=o.normalizePKs?s._normalizePrimaryKey(t):s.schema.getPrimaryKey(t);if(!n)throw new Error(l.default.normalizePk(s.schema.name));var i=o.output[s.schema.name];i.byId[n]||i.ids.push(n);var a=i.byId[n]=u.__assign({},t);return s.schema.getForeignKeys(t).forEach(function(e){s._normalizeForeignKey(e,a,o),s._indexForeignKey(e,i,n)}),s.schema.relations.forEach(function(e){return s._normalizeRelations(e,a,n,o)}),n})},e.prototype._normalizePrimaryKey=function(e){var t=this.schema.getPrimaryKey(e);if(t)return t;var r=this.db.getPkGenerator(this.schema.name);if(r){var n=r(e,this.schema);return n&&1===this.schema.primaryKeys.length&&(e[this.schema.primaryKeys[0].propName]=n),n}},e.prototype._normalizeRelations=function(e,t,r,n){if(e.relationName&&t[e.relationName]){var i=this.schema.inferRelations(t[e.relationName],e,r);e.table.normalize(i,n),delete t[e.relationName]}},e.prototype._normalizeForeignKey=function(e,t,r){if("object"==typeof e.value){var n=e.refTable.normalize(e.value,r);if(1<n.length)throw new Error(l.default.normalizeInvalidFk(this.schema.name,e.name,e.refTable.name));t[e.name]=e.value=n[0]}},e.prototype._indexForeignKey=function(e,t,r){if(c.isValidID(e.value)){var n=c.asID(e.value),i=t.indexes[e.name]||(t.indexes[e.name]={unique:e.unique,values:{}});if(i.values[n]||(i.values[n]=[]),i.unique&&i.values.length)throw new Error(l.default.normalizeFkViolation(this.schema.name,e.name));i.values[n].push(r)}},e}();t.default=n}),define("models/Database",["require","exports","tslib","constants","errors","utils"],function(e,t,i,n,a,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),a=i.__importDefault(a);var o={cascadeAsDefault:!1},u=function(e,t,r){return e?"function"==typeof e?e:e[t]?e[t]:e[n.ALL]?e[n.ALL]:r:r},r=function(){function e(t,e,r){var n=this;this.getRecordNormalizer=function(e){return u(n.options.onNormalize,e)},this.getPkGenerator=function(e){return u(n.options.onGeneratePK,e)},this.getRecordComparer=function(e){return u(n.options.onRecordCompare,e,s.isEqual)},this.getRecordMerger=function(e){return u(n.options.onRecordMerge,e)},this.schema=s.ensureParamObject("schema",t),this.factory=s.ensureParamObject("factory",e),this.options=i.__assign({},o,r),this.tables=Object.keys(t).map(function(e){return n.factory.newTableSchema(n,e,t[e])}),this.tableMap=s.toObject(this.tables,function(e){return e.name}),this.tables.forEach(function(e){return e.connect(n.tableMap)})}return e.prototype.combineReducers=function(){for(var r=this,n=[],e=0;e<arguments.length;e++)n[e]=arguments[e];return function(e,t){return void 0===e&&(e={}),r.reduce(e,t,n)}},e.prototype.reduce=function(e,t,r){var n=this;void 0===e&&(e={});for(var i=[],a=3;a<arguments.length;a++)i[a-3]=arguments[a];var o=this.createSession(e);return s.ensureArray(r).forEach(function(e){return e.apply(n,[o.tables,t].concat(i))}),o.commit()},e.prototype.createSession=function(e,t){return void 0===e&&(e={}),this.factory.newSession(this,e,i.__assign({readOnly:!1},t))},e.prototype.getTableSchema=function(e){return this.tableMap[e]},e.prototype.selectTables=function(e){var t=this;s.ensureParamObject("state",e);var r=Object.keys(e).filter(function(e){return t.tableMap[e]}).map(function(e){return t.tableMap[e]});return this.createSession(e,{readOnly:!0,tableSchemas:r}).tables},e.prototype.selectTable=function(e,t){var r;s.ensureParamObject("tableState",e);var n=e.name,i=void 0===n?t:n;if(!i)throw new Error(a.default.unknownTableState());return this.selectTables((r={},r[i]=e,r))[i]},e}();t.default=r}),define("models/DatabaseSession",["require","exports","tslib","errors","utils"],function(e,t,a,n,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),n=a.__importDefault(n);var r=function(){function e(e,t,r){void 0===r&&(r={});var n=this;this.db=u.ensureParamObject("db",e),this.state=u.ensureParamObject("state",t);var i=r.readOnly,a=void 0!==i&&i,o=r.tableSchemas,s=void 0===o?e.tables:o;this.readOnly=a,this.tables=u.toObject(s.map(function(e){return n.db.factory.newTableModel(n,e,t[e.name])}),function(e){return e.schema.name})}return e.prototype.getTable=function(e){return this.tables[e]},e.prototype.upsert=function(t){var r=this;if(this.readOnly)throw new Error(n.default.sessionReadonly());Object.keys(t.output).forEach(function(e){e!==t.schema.name&&r.tables[e].upsertNormalized(t.output[e])}),Object.keys(t.emits).forEach(function(e){e!==t.schema.name&&r.tables[e].upsert(t.emits[e])})},e.prototype.commit=function(){var i=this;if(this.readOnly)throw new Error(n.default.sessionReadonly());return Object.keys(this.tables).forEach(function(e){var t,r=i.state[e],n=i.tables[e].state;r!==n&&(i.state=a.__assign({},i.state,((t={})[e]=n,t)))}),this.state},e}();t.default=r}),define("models/FieldSchemaModel",["require","exports","tslib","constants","errors","utils"],function(e,t,r,i,n,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),n=r.__importDefault(n);var o=function(){function e(e,t,r,n){void 0===n&&(n=!1),this.table=a.ensureParamObject("table",e),a.ensureParamString("name",t),a.ensureParamObject("schema",r),this.type=r.type||i.TYPE_ATTR,this.name=a.optionalParamString("schema.fieldName",r.fieldName,t),this.propName=a.optionalParamString("schema.propName",r.propName,t),this.references=a.optionalParamString("schema.references",r.references),this.isPrimaryKey=!0===r.pk||r.type===i.TYPE_PK,this.isForeignKey=!!this.references,this.isStamp=!0===r.stamp||r.type===i.TYPE_MODIFIED,this._valueFactory=void 0!==r.value?a.ensureParamFunction("schema.value",r.value).bind(this):void 0,this.isPrimaryKey||this.isForeignKey?(this.isForeignKey&&(this.relationName=a.optionalParamString("schema.relationName",r.relationName)),this.cascade=void 0===r.cascade?n:!0===r.cascade,this.unique=!0===r.unique,this.notNull=void 0===r.notNull||!0===r.notNull):(this.cascade=!1,this.unique=!1,this.notNull=!0===r.notNull)}return Object.defineProperty(e.prototype,"refTable",{get:function(){return this._refTable},enumerable:!0,configurable:!0}),e.prototype.connect=function(e){if(this.references&&(this._refTable=e[this.references],!this._refTable))throw new Error(n.default.fkInvalidReference(this.table.name,this.name,this.references))},e.prototype.getValue=function(e,t){return this._valueFactory?this._valueFactory(e,{record:t,schema:this}):e[this.name]},e.prototype.getRecordValue=function(e){return this.getValue(e.value,e)},e}();t.default=o}),define("models/RecordFieldModel",["require","exports","utils"],function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t){this.schema=r.ensureParamObject("schema",e),this.name=r.ensureParamString("schema.name",e.name),this.record=r.ensureParamObject("record",t)}return Object.defineProperty(e.prototype,"value",{get:function(){return this.schema.getRecordValue(this.record)},enumerable:!0,configurable:!0}),e}();t.default=n}),define("models/RecordModel",["require","exports","utils"],function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t){this.id=r.ensureParamString("id",e),this.table=r.ensureParamObject("table",t)}return Object.defineProperty(e.prototype,"value",{get:function(){return this.table.getValue(this.id)||{}},set:function(e){this.update(e)},enumerable:!0,configurable:!0}),e.prototype.delete=function(){this.table.delete(this.id)},e.prototype.update=function(e){return this.table.schema.injectKeys(e,this),this.table.update(e),this},e}();t.default=n}),define("models/RecordSetModel",["require","exports","tslib","errors","utils"],function(e,t,r,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),n=r.__importDefault(n);var a=function(){function e(e,t,r){this.table=i.ensureParamObject("table",e),this.schema=i.ensureParamObject("schema",t),this.owner=i.ensureParamObject("owner",r,"id")}return Object.defineProperty(e.prototype,"ids",{get:function(){return this.table.getIndex(this.schema.name,this.owner.id)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"length",{get:function(){return this.ids.length},enumerable:!0,configurable:!0}),e.prototype.all=function(){var t=this;return this.ids.map(function(e){return t.table.get(e)})},e.prototype.values=function(){var r=this;return this.ids.map(function(e){var t=r.table.getValue(e);if(!t)throw new Error(n.default.recordNotFound(r.table.schema.name,e));return t})},e.prototype.add=function(e){return this.table.insert(this._normalize(e))},e.prototype.remove=function(e){var t=this,r=this._normalize(e).map(function(e){return t.table.schema.ensurePrimaryKey(e)});return this.table.delete(r)},e.prototype.update=function(e){return this.table.update(this._normalize(e))},e.prototype.delete=function(){this.table.delete(this.ids)},e.prototype._normalize=function(e){return this.table.schema.inferRelations(e,this.schema,this.owner.id)},e}();t.default=a}),define("state",["require","exports","tslib","errors","utils"],function(e,t,o,s,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),s=o.__importDefault(s),t.merge=function(e,t){var r=t.ids?u.mergeIds(e.ids,t.ids,!0):e.ids,n=t.byId?o.__assign({},e.byId,t.byId):e.byId;return o.__assign({},e,{byId:n,ids:r})},t.splice=function(e,t){var i=o.__assign({},e.byId),a=e.ids.slice(),r=o.__assign({},e.indexes);return{deleted:t.reduce(function(e,t){var r=i[t];delete i[t];var n=a.indexOf(t);return 0<=n&&a.splice(n,1),r?e.concat([{id:t,record:r}]):e},[]),state:o.__assign({},e,{byId:i,ids:a,indexes:r})}},t.updateIndexes=function(a,e,o){Object.keys(o.indexes).forEach(function(n){var i=e.indexes[n]||(e.indexes[n]={unique:o.indexes[n].unique,values:{}});Object.keys(o.indexes[n].values).forEach(function(e){var t=i.values[e]||(i.values[e]=[]),r=u.mergeIds(t,o.indexes[n].values[e],!1);if(i.unique&&1<r.length)throw new Error(s.default.fkViolation(a,n));i.values[e]=r})})},t.cleanIndexes=function(e,n,i){e.forEach(function(e){var t=-1;if(e.value&&i[e.name]&&i[e.name].values[e.value]&&(t=i[e.name].values[e.value].indexOf(n)),0<=t){var r=i[e.name].values[e.value].slice();r.splice(t,1),i[e.name].values[e.value]=r}else i[e.name]&&(delete i[e.name].values[n],0===Object.keys(i[e.name].values).length&&delete i[e.name])})},t.default={cleanIndexes:t.cleanIndexes,merge:t.merge,splice:t.splice,updateIndexes:t.updateIndexes}}),define("models/NormalizeContext",["require","exports","utils"],function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e,t){this.output={},this.emits={},this.schema=r.ensureParamObject("schema",e,"db"),this.db=r.ensureParamObject("schema.db",this.schema.db),this.table=t.table,this.normalizePKs=!0===t.normalizePKs,this.argument=t.argument}return e.prototype.emit=function(e,t){this.emits[e]=this.emits[e]||[],this.emits[e].push(t)},e}();t.default=n}),define("models/TableModel",["require","exports","tslib","constants","errors","state","utils","models/NormalizeContext"],function(e,t,n,u,l,s,c,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),l=n.__importDefault(l),s=n.__importDefault(s),c=n.__importStar(c),i=n.__importDefault(i);var r=function(){function e(e,t,r){this.dirty=!1,this.session=c.ensureParamObject("session",e),this.schema=c.ensureParamObject("schema",t),this.state=c.ensureParamObject("state",r||u.initialState(this.schema.name));var n=this.state,i=n.ids,a=n.byId,o=n.indexes,s=n.name;if(!i||!a||!o)throw new Error(l.default.tableInvalidState(t.name));s||(this.state.name=s)}return Object.defineProperty(e.prototype,"length",{get:function(){return this.state.ids.length},enumerable:!0,configurable:!0}),e.prototype.all=function(){var t=this;return this.state.ids.map(function(e){return t.schema.db.factory.newRecordModel(e,t)})},e.prototype.values=function(){var t=this;return this.state.ids.map(function(e){return t.state.byId[e]})},e.prototype.exists=function(e){return!!c.isValidID(e)&&void 0!==this.state.byId[c.asID(e)]},e.prototype.get=function(e){if(!this.exists(e))throw new Error(l.default.recordNotFound(this.schema.name,e));return this.schema.db.factory.newRecordModel(c.asID(e),this)},e.prototype.getOrDefault=function(e){if(this.exists(e))return this.schema.db.factory.newRecordModel(c.asID(e),this)},e.prototype.getValue=function(e){return c.isValidID(e)?this.state.byId[e]:void 0},e.prototype.getIndex=function(e,t){return c.ensureParamString("name",e),c.ensureParamString("fk",t),this.state.indexes[e]&&this.state.indexes[e].values[t]?this.state.indexes[e].values[t]:[]},e.prototype.insert=function(e,t){return this._normalizedAction(e,this.insertNormalized,{normalizePKs:!0,argument:t})},e.prototype.update=function(e,t){return this._normalizedAction(e,this.updateNormalized,{argument:t})},e.prototype.upsert=function(e,t){return this._normalizedAction(e,this.upsertNormalized,{normalizePKs:!0,argument:t})},e.prototype.delete=function(e){var n=this;c.ensureParam("data",e);var t=c.ensureArray(e).map(function(e){return c.isObject(e)?n.schema.ensurePrimaryKey(e):c.ensureID(e)});if(!t.length)return 0;this._deleteCascade(t);var r=s.default.splice(this.state,t),i=r.deleted,a=r.state;return i.forEach(function(e){var t=e.id,r=e.record;return n._cleanIndexes(t,r,a.indexes)}),this.dirty=!0,this.state=a,i.length},e.prototype.deleteAll=function(){this.length&&(this._deleteCascade(this.state.ids),this.state=u.initialState(this.schema.name))},e.prototype.upsertNormalized=function(t){var r=this;c.ensureParamObject("table",t);var n=u.initialState(this.schema.name),i=u.initialState(this.schema.name);t.ids.forEach(function(e){r.exists(e)?(n.ids.push(e),n.byId[e]=t.byId[e]):(i.ids.push(e),i.byId[e]=t.byId[e])}),i.ids.length&&this.insertNormalized(i,!1),n.ids.length&&this.updateNormalized(n,!1),this._updateIndexes(t)},e.prototype.insertNormalized=function(e,t){void 0===t&&(t=!0),c.ensureParamObject("table",e),this.state=s.default.merge(this.state,e),this.dirty=!0,t&&this._updateIndexes(e)},e.prototype.updateNormalized=function(a,e){var o=this;void 0===e&&(e=!0),c.ensureParamObject("table",a);var t=a.ids.reduce(function(e,t){var r;if(!o.exists(t))throw new Error(l.default.recordUpdateViolation(o.schema.name,t));var n=o.state.byId[t],i=o.schema.mergeRecord(n,a.byId[t]);if(o.schema.isModified(n,i)){if(!e)return(r={})[t]=i,r;e[t]=i}return e},null);t&&(this.dirty=!0,this.state=s.default.merge(this.state,{byId:t}),e&&this._updateIndexes(a))},e.prototype.normalize=function(e,t){c.ensureParam("data",e);var r=new i.default(this.schema,n.__assign({table:this,normalizePKs:!0},t));return this.schema.normalize(e,r),r},e.prototype._normalizedAction=function(e,t,r){c.ensureParam("data",e),c.ensureParamFunction("action",t);var n=this.normalize(e,r),i=n.output[this.schema.name];return i&&t.call(this,i),this.session.upsert(n),i.ids},e.prototype._cleanIndexes=function(e,t,r){var n=this.schema.getForeignKeys(t);s.default.cleanIndexes(n,e,r)},e.prototype._updateIndexes=function(e){s.default.updateIndexes(this.schema.name,this.state,e)},e.prototype._deleteCascade=function(e){var t=this,n=this.schema.relations.filter(function(e){return e.relationName&&e.cascade});n.length&&e.forEach(function(e){var r=t.get(e);r&&n.forEach(function(e){var t=e.relationName&&r[e.relationName];t&&t.delete()})})},e}();t.default=r}),define("models/TableSchemaModel",["require","exports","tslib","errors","utils"],function(e,t,o,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),n=o.__importDefault(n),s=o.__importStar(s);var r=function(){function e(t,e,r){var n=this;this._relations=[],this.db=s.ensureParamObject("db",t),this.name=s.ensureParamString("name",e),s.ensureParamObject("definition",r),this.fields=Object.keys(r).map(function(e){return t.factory.newFieldSchema(n,e,r[e])}),this._normalizer=t.factory.newSchemaNormalizer(this),this._primaryKeyFields=this.fields.filter(function(e){return e.isPrimaryKey}),this._foreignKeyFields=this.fields.filter(function(e){return e.isForeignKey}),this._stampFields=this.fields.filter(function(e){return e.isStamp})}return Object.defineProperty(e.prototype,"relations",{get:function(){return this._relations},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"primaryKeys",{get:function(){return this._primaryKeyFields},enumerable:!0,configurable:!0}),e.prototype.connect=function(t){var r=this;s.ensureParamObject("tableMap",t),Object.keys(t).forEach(function(e){return r._relations=r._relations.concat(t[e].fields.filter(function(e){return e.references===r.name}))}),this._foreignKeyFields.forEach(function(e){return e.connect(t)})},e.prototype.inferRelations=function(e,n,i){if(!n.isForeignKey)return e;var a=n.table.fields.filter(function(e){return e.isForeignKey&&e!==n});return s.ensureArray(e).map(function(e){var t,r;return"number"!=typeof e&&"string"!=typeof e||(e=1===a.length?((t={})[a[0].name]=e,t):{id:e}),o.__assign({},e,((r={})[n.name]=i,r))})},e.prototype.normalize=function(e,t){return this._normalizer.normalize(e,t)},e.prototype.injectKeys=function(t,r){if(!t||"object"!=typeof t)return t;var e=this._primaryKeyFields;e.length||(e=this._foreignKeyFields),e.forEach(function(e){void 0===t[e.name]&&(t[e.name]=e.getRecordValue(r))})},e.prototype.ensurePrimaryKey=function(e){var t=this.getPrimaryKey(e);if(!t)throw new Error(n.default.pkNotFound(this.name));return t},e.prototype.getPrimaryKey=function(n){var e=(this._primaryKeyFields.length?this._primaryKeyFields:this._foreignKeyFields).reduce(function(e,t){var r=t.getValue(n);return e&&r?e+"_"+r:r},null);return s.isValidID(e)?s.asID(e):void 0},e.prototype.getForeignKeys=function(t){var r=this;return this._foreignKeyFields.map(function(e){if(!e.references||!e.refTable)throw new Error(n.default.fkInvalid(r.name,e.name));return{name:e.name,notNull:e.notNull,references:e.references,refTable:e.refTable,unique:!0===e.unique,value:t[e.name]}})},e.prototype.isModified=function(r,n){if(0<this._stampFields.length)return this._stampFields.reduce(function(e,t){return e+(t.getValue(r)===t.getValue(n)?1:0)},0)!==this._stampFields.length;var e=this.db.getRecordComparer(this.name);return e?!e(r,n,this):r===n},e.prototype.mergeRecord=function(e,t){var r=this.db.getRecordMerger(this.name);return r?r(e,t,this):o.__assign({},e,t)},e}();t.default=r}),define("models/index",["require","exports","tslib","models/Database","models/DatabaseSession","models/FieldSchemaModel","models/RecordFieldModel","models/RecordModel","models/RecordSetModel","models/TableModel","models/TableSchemaModel"],function(e,t,r,n,i,a,o,s,u,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),n=r.__importDefault(n),i=r.__importDefault(i),a=r.__importDefault(a),o=r.__importDefault(o),s=r.__importDefault(s),u=r.__importDefault(u),l=r.__importDefault(l),c=r.__importDefault(c),t.Database=n.default,t.DatabaseSession=i.default,t.FieldSchemaModel=a.default,t.RecordFieldModel=o.default,t.RecordModel=s.default,t.RecordSetModel=u.default,t.TableModel=l.default,t.TableSchemaModel=c.default}),define("index",["require","exports","tslib","ModelFactory","models/index","Normalizer","constants","models/index","ModelFactory","utils"],function(e,u,l,r,c,t,n,i,a,o){"use strict";Object.defineProperty(u,"__esModule",{value:!0}),r=l.__importDefault(r),t=l.__importDefault(t),o=l.__importStar(o);var s={newTableSchema:function(e,t,r){return new c.TableSchemaModel(e,t,r)},newFieldSchema:function(e,t,r){return new c.FieldSchemaModel(e,t,r)},newTableModel:function(e,t,r){return new c.TableModel(e,t,r)},newRecordSetModel:function(e,t,r){return new c.RecordSetModel(e,t,r)},newRecordFieldModel:function(e,t){return new c.RecordFieldModel(e,t)},newSchemaNormalizer:function(e){return new t.default(e)},newSession:function(e,t,r){return new c.DatabaseSession(e,t,r)}};u.createFactory=function(e,t){return r.default(l.__assign({},s,e),t||c.RecordModel)},u.createDatabase=function(e,t){void 0===t&&(t={});var r=t.factory,n=void 0===r?{}:r,i=t.recordModelClass,a=void 0===i?c.RecordModel:i,o=l.__rest(t,["factory","recordModelClass"]),s=u.createFactory(n,a);return new c.Database(e,s,o)},l.__exportStar(n,u),l.__exportStar(i,u),l.__exportStar(a,u),u.utils=o});